<?php
/**
 * responsive-xili
 * Version 1.1 for latest version 1.8.4.1
 * 2012-12-12
 */
define('RESPONSIVE_XILI_VER', '1.1'); // as style.css

/**
 *  responsive for xili functions -
 *
 */
function parent_xilidev_setup () {
	
	if (is_admin())
		load_textdomain( 'responsive', get_stylesheet_directory() ."/langs/local-" . WPLANG . ".mo" ); // admin msgid terms are also in local of child !
	load_theme_textdomain( 'responsive', STYLESHEETPATH . '/langs' ); // now use .mo of child containing Options terms
	
	$xili_functionsfolder = get_stylesheet_directory() . '/functions-xili' ; 
	if ( file_exists($xili_functionsfolder . '/multilingual-functions.php') && class_exists('xili_language') ) {
		require_once ($xili_functionsfolder . '/multilingual-functions.php');
	}
	if ( file_exists( $xili_functionsfolder . '/multilingual-permalinks.php') && class_exists('xili_language') ) {
		require_once ( $xili_functionsfolder . '/multilingual-permalinks.php' ); // require subscribing premium services
	}
}

/* actions and filters*/
add_action( 'after_setup_theme', 'parent_xilidev_setup', 11 );
add_action( 'wp_head', 'special_head' );

define('XILI_CATS_ALL','0');

/**
 * define when search form is completed by radio buttons to sub-select language when searching
 *
 */
function special_head() {
	?>
	<link rel="shortcut icon" href="<?php bloginfo('stylesheet_directory'); ?>/favicon.ico" type="image/x-icon"/>
	<?php
	// to change search form of widget
	// if ( is_front_page() || is_category() || is_search() )
	echo "<!-- Website powered with child-theme responsive-xili v. ".RESPONSIVE_XILI_VER." of dev.xiligroup.com -->\n";
	if ( is_search() ) {
	 	add_filter('get_search_form', 'my_langs_in_search_form_responsive', 10, 1); // responsive bellow
	}
}

/**
 * introduce filter to translate category->name when called by old function get_category_parents
 *
 */
function xili_responsive_breadcrumb_lists () {
 	
 	add_filter ('get_category', 'xili_responsive_category',10 ,2);
 	responsive_breadcrumb_lists();
 	remove_filter ('get_category', 'xili_responsive_category');
 	
}
function xili_responsive_category ($term, $taxonomy) {
	if ( $taxonomy == 'category' ) { 
		$term->name = __($term->name, 'responsive');
		$term->description = __($term->description, 'responsive');
	}
	return $term;
}

// now here for page and single
function responsive_post_meta_data() {
	printf( __( '<span class="%1$s">Posted on </span>%2$s<span class="%3$s"> by </span>%4$s', 'responsive' ),
	'meta-prep meta-prep-author posted', 
	sprintf( '<a href="%1$s" title="%2$s" rel="bookmark"><span class="timestamp">%3$s</span></a>',
		get_permalink(),
		esc_attr( get_the_time() ),
		get_the_date()
	),
	'byline',
	sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s">%3$s</a></span>',
		get_author_posts_url( get_the_author_meta( 'ID' ) ),
		sprintf( esc_attr__( 'View all posts by %s', 'responsive' ), get_the_author() ),
		get_the_author()
	    )
	);
	
	if ( xiliml_new_list() ) { 
		echo ' <span class="mdash">&mdash;</span> '; 
		xiliml_the_other_posts();
	}
}



/**
 * add search other languages in form - see functions.php when fired
 *
 */
function my_langs_in_search_form_responsive ( $the_form ) {
	$form = $the_form ;
	if ( class_exists('xili_language') ) 
		$form .= '<div class="xili-s-radio">' . xiliml_langinsearchform ( $before='<span class="radio-lang">', $after='</span>', false) . '</div>';
	return $form ;
}


add_action ( 'init', 'xili_create_menu_locations', 100 );

/**
 * filter to create one menu per language for dashboard
 * detect the default one created by theme ($menu_locations_keys[0])
 * @since 0.9.7
 * @updated 1.0.2
 */


function xili_create_menu_locations () {
	$xili_theme_options = xili_child_get_theme_options() ; 
	if ( isset ( $xili_theme_options['nav_menus'] ) && $xili_theme_options['nav_menus'] == 'nav_menus' ) {  // ok for automatic insertion of one menu per lang...
		$menu_locations = get_registered_nav_menus() ; 
		$menu_locations_keys =  array_keys( $menu_locations );
		if ( class_exists('xili_language') ) {
			global $xili_language ;
			$default = 'en_us'; // currently the default language of theme in core WP
			$language_xili_settings = get_option('xili_language_settings');
			$language_slugs_list =  array_keys ( $language_xili_settings['langs_ids_array'] ) ;
			$oneloc = $menu_locations_keys[1]; // header-menu only .menu
			foreach ( $language_slugs_list as $slug ) {
				$one_menu_location = $oneloc.'_'.$slug ; 
				if ( $slug != $default ) {
					register_nav_menu ( $one_menu_location,  sprintf( __('%s for %s','responsive'), $menu_locations[$oneloc], $slug ) );
				}
			}
		} 
	}
}


/**
 * filter to avoid modifying theme's header and changes 'virtually' location for each language
 * @since 0.9.7
 */

add_filter ( 'wp_nav_menu_args', 'xili_wp_nav_menu_args' ); // called at line #145 in nav-menu-template.php

function xili_wp_nav_menu_args ( $args ) {
	if ( class_exists('xili_language') ) {
		global $xili_language ;
		$default = 'en_us'; // currently the default language of theme as in core WP
		$slug = the_curlang();
		if ( $default != $slug ) {
			$theme_location = $args['theme_location'];
			if ( has_nav_menu ( $theme_location.'_'.$slug ) ) { // only if a menu is set by webmaster in menus dashboard
				$args['theme_location'] = $theme_location .'_'.$slug ;
			}	
		}
	}	
	return $args;
}


/**
 * dynamic style for flag depending current list 
 *
 * @since 1.0.2 - add #access
 *
 */
function xili_parent_flags_style () {
	if ( class_exists('xili_language') ) {
		global $xili_language ;
		$language_xili_settings = get_option('xili_language_settings'); 
		if ( !is_array( $language_xili_settings['langs_ids_array'] ) ) { 
			$xili_language->get_lang_slug_ids(); // update array when no lang_perma 110830 thanks to Pierre
			update_option( 'xili_language_settings', $xili_language->xili_settings );
			$language_xili_settings = get_option('xili_language_settings');
		}
	
		$language_slugs_list =  array_keys ( $language_xili_settings['langs_ids_array'] ) ;
		$xili_theme_options = xili_child_get_theme_options() ; // see below
		
		if ( !isset( $xili_theme_options['no_flags'] ) || $xili_theme_options['no_flags'] != 'hidden_flags' ) {
		?>
		<!-- style for ©xili-language menu of responsive child -->
		<style type="text/css">
		
		<?php 
		
		$path = get_stylesheet_directory_uri();
		
		$ulmenus = array();
		foreach ( $language_slugs_list as $slug ) { // only top-menu (.top-menu (1.9.1)
			echo "ul.top-menu li.lang-{$slug} {display:inline-block; background: transparent url('{$path}/images/flags/{$slug}.png') no-repeat center 04px; }\n";
			echo "ul.top-menu li.lang-{$slug}:hover > a {background:#efefef url('{$path}/images/flags/{$slug}.png') no-repeat center 04px !important;}\n";
			$ulmenus[] = "ul.top-menu li.lang-{$slug} a";
		} 
			echo implode (', ', $ulmenus ) . " { display:inline-block; text-indent:-9000px !important; width:6px; border-left:none;}\n";
			echo "ul.top-menu li.menu-separator {display:none;}"; // to hidden separator = visibility:hidden;
			echo "ul.top-menu li.current-lang {display:none;}"; // to hidden separator
		?>
		</style>
		<?php
		}
	}
}

add_action( 'wp_head', 'xili_parent_flags_style' );


/**
 *
 *
 */
function single_lang_dir($post_id) {
	$langdir = ((function_exists('get_cur_post_lang_dir')) ? get_cur_post_lang_dir($post_id) : array());
	if ( isset($langdir['direction']) ) return $langdir['direction'];
} 

/**
 * to avoid display of old xiliml_the_other_posts in singular - only if forced
 * @since 1.1
 */
function xiliml_new_list() {
	if ( class_exists('xili_language') ) {
		global $xili_language;
	
		$xili_theme_options = xili_child_get_theme_options() ; // see below
		
		if ( isset ( $xili_theme_options['linked_posts'] ) &&  $xili_theme_options['linked_posts'] == 'show_linked' ) {
			if (is_page() && is_front_page() ) {
				return false;
			} else {	
				return true;
			}
		} else {
			return false ;
		}	
	}
	return true ;
}

/**
 * Add our theme options page to the admin menu, including some help documentation.
 *
 * This function is attached to the admin_menu action hook.
 *
 * @since Responsive 1.6.9
 */
function xili_child_theme_options_add_page() {
	global $xili_theme_page;
	$xili_theme_page = add_theme_page(
		__( 'xili Options', 'responsive' ), // Name of page
		__( 'xili Options', 'responsive' ), // Label in menu
		'edit_theme_options',                  // Capability required
		'xili_theme_options',                       // Menu slug, used to uniquely identify the page
		'xili_theme_options_render_page'            // Function that renders the options page
	);
	add_action('load-'.$xili_theme_page, 'xili_child_theme_options_help_page');
}

add_action( 'admin_menu', 'xili_child_theme_options_add_page' );


function xili_child_theme_options_help_page () {
	global $xili_theme_page, $wp_version;
	$screen = get_current_screen();
	
	if ( version_compare($wp_version, '3.4', '<') ) {
			$current_theme = get_current_theme() ;
		} else {
			$current_theme = wp_get_theme() ;	
		}
	
	if ( $screen->id != $xili_theme_page )
        return;
	$help = '<p>' . sprintf(__( 'Some themes provide customization options that are grouped together on a Theme Options screen. If you change themes, options may change or disappear, as they are theme-specific. Your current theme, %s, provides the following Theme Options:', 'responsive' ), $current_theme ) . '</p>' .
			'<ol>' .
				'<li>' . __( '<strong>Multilingual Flags style</strong>: Check if you want to hidden flags and see only language names. (no style generated)...', 'responsive' ) . '</li>' .
				'<li>' . __( '<strong>Other posts in other languages links in singular (page or post)</strong>: Check if you want to show links of posts in other languages.', 'responsive' ) . '</li>' .
				
			'</ol>' .
			'<p>' . __( 'Remember to click "Save Changes" to save any changes you have made to the theme options.', 'responsive' ) . '</p>' ;
			
			$menu = '<p>' . sprintf(__( 'Your current theme, %s, provides navigation menus.', 'responsive' ), $current_theme ) . '</p>' .
			'<p>' . sprintf(__( 'In this example, %s, only the header-menu is instantiate able (one menu content for each language) and only the top-menu is ready for flags style.', 'responsive' ), $current_theme ) . '</p>'
			;
			
			$more = 
			'<p><strong>' . __( 'For more information:', 'responsive' ) . '</strong></p>' .
			'<p>' . __( '<a href="http://codex.wordpress.org/Appearance_Theme_Options_Screen" target="_blank">WP Documentation on Theme Options</a>', 'responsive' ) . '</p>' .
			'<p>' . __( '<a href="http://wiki.xiligroup.org" target="_blank">Xili Wiki</a>', 'responsive' ) . '</p>'.
			'<p>' . __( '<a href="http://forum2.dev.xiligroup.com" target="_blank">Xili Support Forums</a>', 'responsive' ) . '</p>';

	$screen->add_help_tab(  array(
        'id'	=> $xili_theme_page,
        'title'	=> __('Help'),
        'content'	=>	$help	));
    $screen->add_help_tab(  array(
        'id'	=> $xili_theme_page.'-menu',
        'title'	=> __('Menu'),
        'content'	=>	$menu	));
    $screen->add_help_tab(  array(
        'id'	=> $xili_theme_page.'-more',
        'title'	=> __('More'),
        'content'	=>	$more	));
}


/**
 * Returns the options array for Responsive.
 *
 * @since Responsive 1.6.9
 *
 * 
 *
 */
function xili_theme_options_render_page() {
	global $wp_version;
	?>
	<div class="wrap">
		<?php screen_icon(); 
		
		if ( version_compare($wp_version, '3.4', '<') ) {
			$current_theme = get_current_theme() ;
		} else {
			$current_theme = wp_get_theme() ;	
		}
		
		?>
		<h2><?php printf( __( '%s Theme Options for multilingual features', 'responsive' ), $current_theme ); ?></h2>
		<?php settings_errors(); ?>

		<form method="post" action="options.php">
			<?php
				settings_fields( 'xili_responsive_options' ); // as in register_settings below
				$options = xili_child_get_theme_options();
				$default_options = xili_child_get_default_theme_options();
				$no_flags = isset( $options['no_flags'] ) ? $options['no_flags'] : "flags";
				$linked_posts = isset( $options['linked_posts'] ) ? $options['linked_posts'] : "no_link";
				$nav_menus = isset( $options['nav_menus'] ) ? $options['nav_menus'] : "";
				$menu_locations = get_registered_nav_menus() ;
				$navmenu_count =  0 ;
				foreach ( $menu_locations as $one_key => $one_location ) { 
						if ( false === strpos( $one_key , '_' ) ) $navmenu_count ++ ; // only core nav menu
				}
				
				
			?>
			<table class="form-table">

				<tr valign="top" class="image-radio-option color-scheme"><th scope="row"><?php _e( 'Style of languages in menu', 'responsive' ); ?></th>
					<td>
						<fieldset><legend class="screen-reader-text"><span><?php _e( 'Flags hidden', 'responsive' ); ?></span></legend>
							<label for="xili_responsive_theme_options[no_flags]" class="selectit"><input name="xili_responsive_theme_options[no_flags]" <?php checked( $no_flags, "hidden_flags" ); ?> type="checkbox" value="hidden_flags" /> <?php _e( 'Flags hidden', 'responsive' ); ?></label>
						</fielset>
					</td>
				</tr>
				<tr valign="top" class="image-radio-option color-scheme"><th scope="row"><?php _e( 'Show Other Posts links in meta in single', 'responsive' ); ?></th>
					<td>
						<fieldset><legend class="screen-reader-text"><span><?php _e( 'Show linked posts', 'responsive' ); ?></span></legend>
							<label for="xili_responsive_theme_options[linked_posts]" class="selectit"><input name="xili_responsive_theme_options[linked_posts]" <?php checked( $linked_posts, "show_linked" ); ?> type="checkbox" value="show_linked" /> <?php _e( 'Show', 'responsive' ); ?></label>
						</fielset>
					</td>
				</tr>
				<tr valign="top" class="image-radio-option color-scheme"><th scope="row"><?php _e( 'Instantiate nav menu for each language', 'responsive' ); ?></th>
					<td>
						<fieldset><legend class="screen-reader-text"><span><?php _e( 'Instantiate nav menus', 'responsive' ); ?></span></legend>
							<label for="xili_responsive_theme_options[nav_menus]" class="selectit"><input name="xili_responsive_theme_options[nav_menus]" <?php checked( $nav_menus, "nav_menus" ); ?> type="checkbox" value="nav_menus" />  <?php _e( 'Instantiate', 'responsive' ); ?></label>
						</fielset>
					</td>
				</tr>
				<?php 
				
				if ( $navmenu_count > 1000 )  { // not used here
				?>
				<tr valign="top" class="image-radio-option color-scheme"><th scope="row"><?php printf (__( 'Enable (or not) language instantiation for these registered menus<br /> After changes saved, <a href="%s" >go to Nav Menus</a> and save theme locations', 'responsive' ) , 'nav-menus.php'); ?></th>
					<td>
					<?php foreach ( $menu_locations as $one_key => $one_location ) { 
						if ( false === strpos( $one_key , '_' ) ) {
							$indice = 'nav_menu_'.$one_key ;
							$nav_value = isset( $options[$indice] ) ? $options[$indice] : "";
						?>
						<fieldset>
							<label for="xili_responsive_theme_options[<?php echo $indice ?>]" class="selectit"><input name="xili_responsive_theme_options[<?php echo $indice ?>]" <?php checked( $nav_value, "nav_menu" ); ?> type="checkbox" value="nav_menu" /><?php echo $one_location ; ?></label>
						</fielset>
					<?php } } ?>	
					</td>
				</tr>
				
				<?php } ?>
			</table>
			<p><small>responsive-xili v. <?php echo RESPONSIVE_XILI_VER; ?>, a multilingual child example by <a href="http://child-theme.wpmu.xilione.com" >dev.xiligroup.com</a> (©2011-2012)</small></p>
			<?php submit_button(); ?>
		</form>
	</div>
<?php
}

/**
 * Returns the options array.
 *
 * @since Responsive 1.6.9
 */
function xili_child_get_theme_options() {
	return get_option( 'xili_responsive_theme_options', xili_child_get_default_theme_options() );
}

function xili_child_get_default_theme_options() {
	return array( 'no_flags' => false , 'linked_posts' => 'show_linked',  'nav_menus' => false) ;
}

function xili_responsive_theme_options_init() {

	// If we have no options in the database, let's add them now.
	if ( false === xili_child_get_theme_options() )
		add_option( 'xili_responsive_theme_options', xili_child_get_default_theme_options() );

	register_setting(
		
		'xili_responsive_options', // prefix xili_ to avoid conflict with parent - thanks to sylvia - 
		'xili_responsive_theme_options'
	);
}
add_action( 'admin_init', 'xili_responsive_theme_options_init' );

?>